#ifndef VHTTPD_SOCKET_H
#define VHTTPD_SOCKET_H

#include <sys/types.h>
#include <vhttpd/buffer.h>

#define FLAG_ISSET(state,mask) (((state) & (mask)) == (mask))
typedef enum {
    C_SO_FATAL =    (01 << 0),
    C_SO_NOBLK =    (01 << 1),
    C_SO_SERVER =   (01 << 2)
} inet_socket_flag_t;

int create_inet_socket (const char *addr, const char *service, int flags);
int create_unix_socket (const char *path, int flags);
void unix_socket_set_ownership(const char *path, const char *user, const char *group);

void close_socket (int);

int socket_accept (int, char **,int);
int socket_send (int, const void *, size_t);
int socket_sendfile (int, int, size_t);
int socket_receive (int, buffer_t *);

#endif
